#include <iostream>
#include <boost/variant/apply_visitor.hpp>
#include <boost/variant/variant.hpp>
#include <memory>
#include <functional>

void foo(int, std::unique_ptr<int>)
{
    std::cout << "foo(int) called" << std::endl;
}

void foo(double, std::unique_ptr<int>)
{
    std::cout << "foo(double) called" << std::endl;
}

using MsgType = boost::variant<int, double>;

int main(int argc, char* argv[])
{
    MsgType intMsg{int{0}};
    std::unique_ptr<int> number(new int(42));

    auto func = [capturedNumber = std::move(number)](const auto& msg) mutable -> auto {
        foo(msg, std::move(capturedNumber));
    };

    boost::apply_visitor(func, intMsg);

    boost::apply_visitor(
            [capturedNumber = std::move(number)](const auto& msg) mutable -> auto {
                foo(msg, std::move(capturedNumber));
            }
            , intMsg); //not working

    return 0;
}
